#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "nmb.h"

int udp_port = 137;

int
format_packet (void *buffer, int maxlen, struct in_addr addr)
{
  static char name[64] = "CKAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA\0";
  struct nmbhdr *nmb;
  struct typez *typz;
  char *data;

  if (maxlen < 50)
    return -1;

  memset (buffer, 0, 50);


  nmb = (struct nmbhdr *) buffer;
  data = (char *) (buffer + NMBHDRSIZE);
  typz = (struct typez *) (buffer + NMBHDRSIZE + 33);

  memcpy (data, name, 33);
  nmb->id = 0x003;
  nmb->R = 0;			/* 0 for question 1 for response */
  nmb->opcode = 0;		/* 0 = query */
  nmb->que_num = htons (1);	/* i have only 1 question :) */
  nmb->namelen = 0x20;
  typz->type = 0x2100;
  typz->type2 = 0x1000;


  return 50;
}

int
received_packet (void *buffer, int len, struct in_addr addr)
{
  struct nmbhdr *nmb;
  unsigned char *data;
  char name[0x40];
  int i;

  nmb = (struct nmbhdr *) (buffer);
  data = (unsigned char *) (buffer + 50 + 7);

  if (nmb->rep_num == 0)
    return 0;

  for (i = 0; (i < 0x3F) && (data[i] > 0x20); i++)
    name[i] = data[i];
  name[i++] = 0;

  printf ("%s %s\n", inet_ntoa (addr), (char *) name);
  fflush (stdout);
  return 1;
}
